(** A representation for program variables. *)

(** Linear terms are represented by trees (see {! Rtree}).
A value of type [t] identifies a variable and represents a path in a tree.
[XH] is the end of a path, [XO] means "take the left branch" and [XI] means "take the right branch". *)
type t = XH | XO of t | XI of t

(** [next v] gives the path to the next variable in a breadth-first search in a tree.
Next of [... XO XH] is [... XI XH],
next of [... XO (XI XH)] is [... XI (XO XH)] and
next of [XI (XI XH)] is [XO (XO (XO XH))]. *)
val next: t -> t
