Module Q.
  Require Import NArith.
  Require Import ZArith.
  Require Import QArith.

(* XXX: The proofs in this module are ugly. *)

  Lemma PZMul: forall n1 n2 n3: positive, Zmult (Zpos n1) (Zpos (Pmult n2 n3)) = Zmult (Zpos (Pmult n1 n2)) (Zpos n3).
    intros n1 n2 n3; unfold Zmult; rewrite Pmult_assoc; trivial.
  Qed.

  Lemma Qplus_lt_compat: forall n1 n2 n3 n4: Q, Qlt n1 n2 -> Qlt n3 n4 -> Qlt (Qplus n1 n3) (Qplus n2 n4).
    unfold Qlt, Qplus.
    intros [n1 d1] [n2 d2] [n3 d3] [n4 d4].
    simpl.
    intros h1 h2.
    repeat ring_simplify.
    apply Zplus_lt_compat.

    rewrite (Pmult_comm d2 d4), (Pmult_comm d1 d3).
    repeat rewrite <- Zmult_assoc.
    rewrite (PZMul d3 d4 d2), (PZMul d4 d3 d1).
    rewrite (Zmult_comm (Zpos (Pmult d3 d4)) (Zpos d2)). 
    rewrite (Zmult_comm (Zpos (Pmult d4 d3)) (Zpos d1)).
    repeat rewrite Zmult_assoc.
    rewrite (Pmult_comm d4 d3).
    apply Zmult_lt_compat_r;
      [ apply Zgt_lt; apply Zgt_pos_0 | assumption ].

    rewrite (Pmult_comm d2 d4), (Pmult_comm d1 d3).
    rewrite (Zmult_comm (Zpos (Pmult d4 d2)) n3), (Zmult_comm (Zpos (Pmult d3 d1)) n4).
    repeat rewrite <- Zmult_assoc.
    repeat rewrite <- PZMul.
    repeat rewrite Zmult_assoc.
    rewrite (Pmult_comm d2 d1).
    apply Zmult_lt_compat_r;
    [ apply Zgt_lt; apply Zgt_pos_0 | assumption ].
  Qed.

  Lemma Qplus_eqlt_compat: forall n1 n2 n3 n4: Q, n1 = n2 -> Qlt n3 n4 -> Qlt (Qplus n1 n3) (Qplus n2 n4).
    intros [n1 d1] [n2 d2] [n3 d3] [n4 d4] h1.
    rewrite h1.
    unfold Qlt, Qplus.
    simpl.
    intro h2.
    repeat ring_simplify.
    rewrite <- (Zmult_assoc n2 (Zpos d3) (Zpos (Pmult d2 d4))), <- (Zmult_assoc n2 (Zpos d4) (Zpos (Pmult d2 d3))).
    rewrite (Pmult_comm d2 d4), (Pmult_comm d2 d3).
    rewrite (PZMul d3 d4 d2), (PZMul d4 d3 d2).
    rewrite (Pmult_comm d4 d3).
    apply Zplus_lt_compat_l.
    rewrite (Zmult_comm (Zpos (Pmult d4 d2)) n3).
    rewrite <- Zmult_assoc.
    rewrite <- (PZMul d4 d2 d2).
    rewrite Zmult_assoc.
    rewrite (Pmult_comm d3 d2).
    rewrite (PZMul d2 d2 d3).
    rewrite <- (Zmult_assoc (Zpos (Pmult d2 d2)) (Zpos d3) n4).
    rewrite (Zmult_comm (Zpos (Pmult d2 d2)) (Zmult (Zpos d3) n4)).
    rewrite (Zmult_comm (Zpos d3) n4).
    apply Zmult_lt_compat_r;
    [ apply Zgt_lt; apply Zgt_pos_0 | assumption ].
  Qed.

End Q.

Module Qc.
  Require Import QArith.
  Require Import Qcanon.

  Lemma Qcplus_lt_compat: forall n1 n2 n3 n4: Qc,
      Qclt n1 n2 -> Qclt n3 n4 -> Qclt (Qcplus n1 n3) (Qcplus n2 n4).
    unfold Qcplus, Qclt, Q2Qc, this.
    intros [n1 nP1] [n2 nP2] [n3 nP3] [n4 nP4] h1 h2.
    repeat rewrite Qred_correct.
    apply Q.Qplus_lt_compat; assumption.
  Qed.

  Lemma Qcplus_eqlt_compat: forall n1 n2 n3 n4: Qc,
      n1 = n2 -> Qclt n3 n4 -> Qclt (Qcplus n1 n3) (Qcplus n2 n4).
    intros [n1 nP1] [n2 nP2] [n3 nP3] [n4 nP4] h1; rewrite h1.
    unfold Qcplus, Qclt, Q2Qc, this.
    repeat rewrite Qred_correct.
    apply Q.Qplus_eqlt_compat; trivial.
  Qed.

End Qc.
