OPT=1
include $(ROOT)/config.mk

CMIPATH := -I,$(OCLOCK),-I,$(LIBCHECK_D),-I,$(LIBPOLY_D)
LIBPATH := -I,$(ZARITH),$(CMIPATH)
LIBS := oclock,zarith,libcheck,libpoly

.PHONY: all

all: bench.out db.out

db.out: bench.out
	sed -n -e 's/^(\* \(Db\..*;\) \*)$$/\1/p' Assign[0-9]*.ml Chull[0-9]*.ml Incl[0-9]*.ml Meet[0-9]*.ml bench.out | sed 's/#/$B/' > db.out
	cp db.out ../../db/$B_$$(date +%Y%m%d%H%M%S)

bench.out: runbench
	./runbench > bench.out

runbench: Main.ml
	ocamlbuild -cflags $(CMIPATH) -lflags $(LIBPATH) -libs $(LIBS) Main.native
	ln Main.native runbench

Main.ml: infile.bc $(WRAPPER)
	$(PAGAI) -d pk -t s -i infile.bc -o /dev/null
